package models

import (
	"encoding/xml"
)

type MxGraphModel struct {
	XMLName xml.Name `xml:"mxGraphModel"`

	Root struct {
		XMLName xml.Name `xml:"root"`
		MxCell  []MxCell `xml:"mxCell"`
	}
}

type MxCell struct {
	XMLName xml.Name `xml:"mxCell"`
	ID      string   `xml:"id,attr"`
	Parent  *string  `xml:"parent,attr"`
	RID     *string  `xml:"rID,attr"`
	Source  *string  `xml:"source,attr"`
	Target  *string  `xml:"target,attr"`
}

type mxissue struct {
	msg string
}

func (m *mxissue) Error() string {
	return m.msg
}

func newMxIssue(message string) error {
	return &mxissue{message}
}
