# \ScheduleApi

All URIs are relative to *https://localhost:49618/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ScheduleControllerCheckIfScheduleCanBeCreatedInThisDC**](ScheduleApi.md#ScheduleControllerCheckIfScheduleCanBeCreatedInThisDC) | **Post** /schedule/check | 
[**ScheduleControllerCreateSchedule**](ScheduleApi.md#ScheduleControllerCreateSchedule) | **Post** /schedule/book | 
[**ScheduleControllerGetNextSchedule**](ScheduleApi.md#ScheduleControllerGetNextSchedule) | **Get** /schedule/next | 
[**ScheduleControllerGetPreviousSchedule**](ScheduleApi.md#ScheduleControllerGetPreviousSchedule) | **Get** /schedule/previous | 
[**ScheduleControllerGetSchedules**](ScheduleApi.md#ScheduleControllerGetSchedules) | **Get** /schedule/ | 


# **ScheduleControllerCheckIfScheduleCanBeCreatedInThisDC**
> ScheduleControllerCheckIfScheduleCanBeCreatedInThisDC(ctx, cron, duration, startDate, stopDate, requirements)


Check for availability of this DC

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **cron** | **string**| Cron syntax | 
  **duration** | **int32**| Duration in seconds | 
  **startDate** | [**interface{}**](.md)| RFC3339 time for startDate | 
  **stopDate** | [**interface{}**](.md)| RFC3339 time for stopDate | 
  **requirements** | [**ModelsExecutionRequirementsModel**](ModelsExecutionRequirementsModel.md)| The object content | 

### Return type

 (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ScheduleControllerCreateSchedule**
> ModelsScheduleInfo ScheduleControllerCreateSchedule(ctx, dcName, workflowName, cron, duration, startDate, stopDate, requirements)


Create schedule for a workflow. It will return some future executions just as information

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **dcName** | **string**| Name of the node (oc-catalog) from where the workflow comes. | 
  **workflowName** | **string**| Workflow Name | 
  **cron** | **string**| Cron syntax with year. If no year is specified, will use the current | 
  **duration** | **int32**| Duration in seconds | 
  **startDate** | [**interface{}**](.md)| RFC3339 time for startDate | 
  **stopDate** | [**interface{}**](.md)| RFC3339 time for stopDate | 
  **requirements** | [**ModelsExecutionRequirementsModel**](ModelsExecutionRequirementsModel.md)| The object content | 

### Return type

[**ModelsScheduleInfo**](models.ScheduleInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ScheduleControllerGetNextSchedule**
> TimeTime ScheduleControllerGetNextSchedule(ctx, baseDate)


Give a date, get the next date where there are at least on schedule. If no hours specified, will assume 00:00

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **baseDate** | [**interface{}**](.md)| Base date | 

### Return type

[**TimeTime**](*time.Time.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ScheduleControllerGetPreviousSchedule**
> TimeTime ScheduleControllerGetPreviousSchedule(ctx, baseDate)


Give a date, get the previous date where there are at least on schedule. If no hours specified, will assume 00:00

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **baseDate** | [**interface{}**](.md)| Base date | 

### Return type

[**TimeTime**](*time.Time.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ScheduleControllerGetSchedules**
> []ModelsScheduleDb ScheduleControllerGetSchedules(ctx, startDate, stopDate)


Get a list of next startDates schedules (inclusive). If timezone is not specified, will assume UTC

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **startDate** | [**interface{}**](.md)| Start date | 
  **stopDate** | [**interface{}**](.md)| End date | 

### Return type

[**[]ModelsScheduleDb**](models.ScheduleDB.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

